## piuparts 0.62~bpo70+1

=== Makefile ===
prefix = /usr/local
sbindir = $(prefix)/sbin
sharedir = $(prefix)/share
mandir = $(sharedir)/man
man1dir = $(mandir)/man1
man8dir = $(mandir)/man8
libdir = $(prefix)/lib
docdir = $(prefix)/share/doc/piuparts/
site27 = $(libdir)/python2.7/dist-packages
htdocsdir	 = $(sharedir)/piuparts/htdocs
etcdir = $(prefix)/etc

distribution=${shell dpkg-parsechangelog | sed -n 's/^Distribution: *//p'}
ifeq ($(distribution),UNRELEASED)
version		:= ${shell echo "`dpkg-parsechangelog | sed -n 's/^Version: *//p'`~`date +%Y%m%d%H%M`~`git describe --dirty`"}
else
version		:= ${shell dpkg-parsechangelog | sed -n 's/^Version: *//p'}
endif


# generate several scripts, conffiles, ... from templates (*.in, *.py)
# by substituting placeholders
SCRIPTS_TEMPLATES	 = $(wildcard *.in master-bin/*.in slave-bin/*.in conf/*.in)
SCRIPTS_PYTHON_BINARY	 = $(wildcard *.py master-bin/*.py slave-bin/*.py)
SCRIPTS_GENERATED	 = $(SCRIPTS_TEMPLATES:.in=) $(SCRIPTS_PYTHON_BINARY:.py=)
DOCS_GENERATED		 = piuparts.1 piuparts.1.html piuparts_slave_run.8 piuparts_slave_join.8 README.html README_server.html

define placeholder_substitution
	sed -r \
	-e 's/__PIUPARTS_VERSION__/$(version)/g' \
	-e 's%@sharedir@%$(sharedir)%g' \
	$< > $@
endef

%: %.in Makefile
	$(placeholder_substitution)

%: %.py Makefile
	$(placeholder_substitution)


all: build

python_scripts	 = $(wildcard *.py piupartslib/*.py master-bin/*.py slave-bin/*.py)
python-syntax-check:
	@set -e -x; $(foreach py,$(python_scripts),python -m py_compile $(py);)
	$(RM) $(python_scripts:=c)

build: build-stamp

build-stamp: $(SCRIPTS_GENERATED) $(DOCS_GENERATED) Makefile
	$(MAKE) python-syntax-check
	touch $@

build-doc: $(DOCS_GENERATED)

README.html: README.txt
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README.txt

README_server.html: README_server.txt
	a2x --copy -a toc -a toclevels=3 -f xhtml -r /etc/asciidoc/ README_server.txt

piuparts.1: piuparts.1.txt
	a2x -f manpage piuparts.1.txt

piuparts_slave_run.8: piuparts_slave_run.8.txt
	a2x -f manpage piuparts_slave_run.8.txt

piuparts_slave_join.8: piuparts_slave_join.8.txt
	a2x -f manpage piuparts_slave_join.8.txt

piuparts.1.html: piuparts.1.txt
	a2x --copy -f xhtml piuparts.1.txt

install-doc: build-stamp
	install -d $(DESTDIR)$(docdir)/
	install -m 0644 README.txt README.html README_server.txt README_server.html docbook-xsl.css $(DESTDIR)$(docdir)/
	install -d $(DESTDIR)$(man1dir)
	install -m 0644 piuparts.1 $(DESTDIR)$(man1dir)/
	install -d $(DESTDIR)$(man8dir)
	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 $(DESTDIR)$(man8dir)/
	gzip -9f $(DESTDIR)$(man1dir)/piuparts.1
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_run.8
	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_join.8
	install -m 0644 piuparts.1.html $(DESTDIR)$(docdir)/

install-conf: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/piuparts.conf.sample $(DESTDIR)$(etcdir)/piuparts/piuparts.conf
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(etcdir)/apache2/conf-available
	install -m 0644 conf/piuparts-master.conf $(DESTDIR)$(etcdir)/apache2/conf-available/

install-conf-4-running-from-git: build-stamp
	install -d $(DESTDIR)$(etcdir)/piuparts
	install -m 0644 conf/crontab-master $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/crontab-slave $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 conf/distros.conf $(DESTDIR)$(etcdir)/piuparts/
	install -m 0644 instances/piuparts.conf.* $(DESTDIR)$(etcdir)/piuparts/
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 update-piuparts-slave-setup $(DESTDIR)$(sharedir)/piuparts/slave/
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 update-piuparts-master-setup $(DESTDIR)$(sharedir)/piuparts/master/

install: build-stamp
	install -d $(DESTDIR)$(sbindir)
	install -m 0755 piuparts $(DESTDIR)$(sbindir)/

	install -d $(DESTDIR)$(sharedir)/piuparts
	install -m 0755 piuparts-slave piuparts-master piuparts-master-backend piuparts-report piuparts-analyze $(DESTDIR)$(sharedir)/piuparts/

	install -d $(DESTDIR)$(site27)/piupartslib
	install -m 0644 piupartslib/*.py $(DESTDIR)$(site27)/piupartslib/

	install -d $(DESTDIR)$(sharedir)/piuparts/lib
	install -m 0644 lib/*.sh $(DESTDIR)$(sharedir)/piuparts/lib/

	# do not install the templates (*.in, *.py)
	install -d $(DESTDIR)$(sharedir)/piuparts/master
	install -m 0755 $(filter-out %.in %.py,$(wildcard master-bin/*)) $(DESTDIR)$(sharedir)/piuparts/master/

	install -d $(DESTDIR)$(sharedir)/piuparts/known_problems
	install -m 0644 known_problems/*.conf $(DESTDIR)$(sharedir)/piuparts/known_problems/

	# do not install the templates (*.in, *.py)
	install -d $(DESTDIR)$(sharedir)/piuparts/slave
	install -m 0755 $(filter-out %.in %.py,$(wildcard slave-bin/*)) $(DESTDIR)$(sharedir)/piuparts/slave/

	install -d $(DESTDIR)$(htdocsdir)
	install -m 0644 htdocs/*.* $(DESTDIR)$(htdocsdir)/

	install -d $(DESTDIR)$(htdocsdir)/images
	install -m 0644 htdocs/images/*.* $(DESTDIR)$(htdocsdir)/images/

	install -d $(DESTDIR)$(htdocsdir)/templates/mail
	install -m 0644 bug-templates/*.mail $(DESTDIR)$(htdocsdir)/templates/mail/

	install -d $(DESTDIR)$(etcdir)/piuparts
	@set -e -x ; \
	for d in $$(ls custom-scripts) ; do \
		install -d $(DESTDIR)$(etcdir)/piuparts/$$d ; \
		install -m 0755 custom-scripts/$$d/* $(DESTDIR)$(etcdir)/piuparts/$$d/ ; done

	#install -d $(DESTDIR)$(etcdir)/piuparts/known_problems
	#install -m 0644 known_problems/*.conf $(DESTDIR)$(etcdir)/piuparts/known_problems/


check:
	# nosetests --verbose

clean:
	rm -f build-stamp
	rm -f $(DOCS_GENERATED)
	rm -f piuparts.1.xml README.xml README_server.xml docbook-xsl.css piuparts.html
	rm -f *.pyc piupartslib/*.pyc master-bin/*.pyc slave-bin/*.pyc tests/*.pyc
	rm -f $(SCRIPTS_GENERATED)


# for maintainer convenience only
tg-deps:
	tg summary --graphviz | dot -T png -o deps.png
	xli deps.png &

=== debian/changelog ===
piuparts (0.62~bpo70+1) wheezy-backports; urgency=medium

  * Rebuild for wheezy-backports.
  * Remove python-mox3 from build-depends and disable the tests during build. 

 -- Holger Levsen <holger@debian.org>  Fri, 09 Jan 2015 12:15:22 +0100

piuparts (0.62) unstable; urgency=medium

  * Default to http://http.debian.net/debian instead of the deprecated
    http://cdn.debian.net service as default mirror. (Closes: #774471)

 -- Holger Levsen <holger@debian.org>  Tue, 06 Jan 2015 10:36:39 +0100

piuparts (0.61) unstable; urgency=medium

  [ Michael Prokop ]
  * Support new scripts directive 'post_chroot_unpack', useful for adding
    apt-keys for custom apt repositories. (Closes: #767485)
  * Add custom-scripts/scripts-unused-examples/post_chroot_unpack_key_setup.

  [ Holger Levsen ]
  * piuparts.py: Add "/var/cache/apt/archives/partial/" to ignored_files.
    (Closes: #767489)
  * piuparts.py and piuparts-report: Detect four more (in)adequate issues:
    - broken-binfmt-detector
    - broken-binfmt-interpreter
    - missing-alternative
    - program-name-collision
    (Closes: #767499)
  * distros.conf: Remove unneeded URI for squeeze-lts, it just uses the
    default repository.
  * instances/pejacevic+slaves: Do not reschedule passed squeeze logs anymore.

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/modules-load.d/modules.conf  (dangling symlink to ../modules)
    - Place an up-to-date copy of the host's /etc/resolv.conf (with comments
      stripped and whitespace normalized) in the chroot.
  * piuparts.conf:
    - Add flags-start-jessie, flags-end-jessie global variables.
    - Use --scriptsdir .../scripts-jessie for tests ending in jessie.
    - Enable --warn-on-debsums-errors for wheezy2jessie upgrades.
  * piuparts.conf.anbe: Add many more example sections.
  * distros.conf:
    - Add *updates, *backports, *proposed for jessie.
    - Switch 'testing' alias to 'stretch', but deactivate it for stable.
    - Add 'stable' alias pointing to 'jessie', deactivated as well.
  * piupartslib/dwke.py:
    - Fix parsing of known_problems/*.conf that have EXCLUDE_PATTERN.
  * piuparts-slave.py:
    - Avoid a busy loop by suspending a section for 5 minutes if basetgz
      creation is in progress or failed.
  * Add "AddDefaultCharset utf-8" to the apache2 configuration snipplet
    example, so that logfiles are displayed as UTF-8.
  * master-bin/detect_piuparts_issues: Another partial write error from tar.
  * pre_install_foreign_architecture: New script to enable foreign
    architectures for testing cross toolchain packages.
  * pre_remove_40_find_unowned_lib_links, unowned_lib_symlink_*.conf: New
    script and reports for unowned symlinks in [/usr]/lib[/<triplet>].
  * post_distupgrade_exceptions: Handle libdb5.1 removal in jessie.
  * scripts-jessie/post_setup_jessie-fake-essential: New custom script.
    - Make ucf fake-essential. (ucf may be used unconditionally during purge.)
    - Make init-system-helpers fake-essential. (Systemd service link cleanup.)
  * Rework the file-rc/sysvinit/upstart/systemd specific exceptions.
  * Remove debugging output for resolvconf.
  * Update custom scripts handling databases, experimental, ... and some more.
  * Update bug templates.

 -- Holger Levsen <holger@debian.org>  Wed, 03 Dec 2014 19:55:26 +0100

piuparts (0.60) unstable; urgency=medium

  [ Leo Iannacone ]
  * piuparts.py: when using the --existing-chroot option, instead of copying
    files, use hard links if the original chroot and destination directory
    are on the same device. (Closes: #754878)

  [ Iain Lane ]
  * Use python-distro-info to get the Debian and Ubuntu devel releases.
  * tests: Remove the Ubuntu devel release test.

  [ Holger Levsen ]
  * Update README_server.txt and README_pejacevic.txt after setting up a
    piuparts master/slave system from packages myself.
  * Drop conf/piuparts-master.sudoers from debian/piuparts-master.examples
    and include all commands piupartss needs to run as root in
    conf/piuparts-slave.sudoers.
  * Update instances/piuparts.conf* to match what is in use for
    piuparts.debian.org today. Add two new systems, goldwasser and lamarr, as
    examples taken from piuparts development.
  * Add "AddType text/plain .log" to the apache2 configuration snipplet
    example, so that logfiles are displayed in the browser.
  * Bump standards version to 3.9.6, no changes needed.
  * Replace all occurrences of old gitweb Alioth URLs with cgit ones.

 -- Holger Levsen <holger@debian.org>  Sun, 26 Oct 2014 20:07:24 +0100

=== debian/control ===
Source: piuparts
Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
Uploaders:
 Holger Levsen <holger@debian.org>
Section: devel
Priority: extra
Standards-Version: 3.9.6
Build-Depends:
 debhelper (>= 9.20120909~),
 python (>= 2.7),
 python-debian,
 python-apt,
 python-distro-info,
 python-nose,
 python-debianbts,
 python-yaml
Build-Depends-Indep:
 asciidoc,
 git,
 xmlto
Homepage: https://piuparts.debian.org
Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
Vcs-Browser: https://anonscm.debian.org/cgit/piuparts/piuparts.git
X-Python-Version: >= 2.7

Package: piuparts
Architecture: all
Pre-Depends:
 dpkg (>= 1.15.7.2~),
Depends:
 piuparts-common (= ${binary:Version}),
 debootstrap,
 debsums,
 lsb-release,
 lsof,
 python-debian,
 ${misc:Depends},
 ${python:Depends}
Recommends:
 adequate
Suggests:
 schroot
Description: .deb package installation, upgrading, and removal testing tool
 piuparts tests that .deb packages (as used by Debian) handle
 installation, upgrading, and removal correctly. It does this by
 creating a minimal Debian installation in a chroot, and installing,
 upgrading, and removing packages in that environment, and comparing the
 state of the directory tree before and after. piuparts reports any
 files that have been added, removed, or modified during this process.
 .
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.

Package: piuparts-master
Architecture: all
Depends:
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-server,
 python-debianbts,
 tango-icon-theme,
 xz-utils,
 python-yaml,
 ${misc:Depends},
 ${python:Depends}
Recommends:
 apache2 | httpd,
 ghostscript,
 python-rpy2,
 r-base-dev,
 r-recommended,
 devscripts,
 libsoap-lite-perl,
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts master components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This package provides the piuparts-master, which needs one or more slaves to
 operate. It also contains piuparts-reports to generate web pages with the
 testing results as well as documentation.

Package: piuparts-slave
Architecture: all
Depends:
 piuparts (= ${binary:Version}),
 piuparts-common (= ${binary:Version}),
 adduser,
 openssh-client,
 screen,
 sudo,
 ${misc:Depends},
 ${python:Depends}
Suggests:
 schroot
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: piuparts slave components
 piuparts is meant as a quality assurance tool for people who create .deb
 packages to test them before they upload them to the Debian package archive.
 A master/slave piuparts installation is used for testing complete archives
 as it is done on https://piuparts.debian.org/.
 .
 This package provides the piuparts slave components, which need a piuparts
 master to operate. See the documentation in the piuparts-master package.

Package: piuparts-common
Architecture: all
Depends:
 python-apt,
 python-distro-info,
 ${misc:Depends},
 ${python:Depends}
Breaks:
 piuparts (<= 0.44)
Replaces:
 piuparts (<= 0.44)
Description: common piuparts components
 piupartslib, common library used by piuparts-master, -reports, -analyze and
 -slave.
 .
 See https://piuparts.debian.org or the piuparts package to learn more about
 piuparts.

## piuparts 0.62

=== debian/control ===
--- 
+++ 
@@ -13,7 +13,8 @@
  python-distro-info,
  python-nose,
  python-debianbts,
- python-yaml
+ python-yaml,
+ python-mox3
 Build-Depends-Indep:
  asciidoc,
  git,

## piuparts 0.62+deb8u1

=== debian/changelog ===
piuparts (0.62+deb8u1) stable; urgency=medium

  [ Stefano Rivera ]
  * Don't test the current Debian release status, tracking that is
    distro-info-data's problem. (Closes: #827411)

 -- Holger Levsen <holger@debian.org>  Fri, 02 Sep 2016 20:23:20 +0200

## piuparts 0.64ubuntu1

=== Makefile ===
--- 
+++ 
@@ -146,7 +146,7 @@
 
 
 check:
-	# nosetests --verbose
+	nosetests --verbose
 
 clean:
 	rm -f build-stamp

=== debian/changelog ===
piuparts (0.64ubuntu1) wily; urgency=medium

  * Fix devpts mounting to use the correct gid=5,mode=620 mount options.

 -- Adam Conrad <adconrad@ubuntu.com>  Mon, 05 Oct 2015 15:50:34 -0600

piuparts (0.64) unstable; urgency=medium

  [ Holger Levsen ]
  * Add FancyIndexing to piuparts-master.conf and enable apache syntax
    highlighting in vim. (Thanks DSA!)
  * Use httpredir.debian.org instead of http.debian.net. (Closes: #783617)
  * Add support for adequate tag missing-pkgconfig-dependency.
    (Closes: #783528)
  * Use revdate: in the asciidoc headers of manpages instead of DATE in the
    body to achieve reproducible builds and set the revdate: to the last
    modification date of each manpage.

  [ Andreas Beckmann ]
  * piuparts.py:
    - Use 'dpkg-query -W' instead of 'dpkg --get-selections' to record
      architecture and version information for installed packages, too.
    - Restore the selections to the package versions from the reference chroot
      in scenarios like sid+experimental where more than one version could be
      available. Use --force-yes since this may involve downgrades.
  * piuparts.conf:
    - New global setting: basetgz-sections, used by piuparts-slave only.
    - Switch to separate tarball sections.
  * piuparts-slave.py:
    - Add support for special sections that only create/refresh reference
      basetgz tarballs without testing packages. The basetgz can be shared
      between multiple sections without being affected by their flags.

 -- Holger Levsen <holger@debian.org>  Fri, 12 Jun 2015 13:42:52 +0200

piuparts (0.63) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/clamav/
      + /etc/lighttpd/
      + /etc/lighttpd/conf-available/
    - Increase verbosity when reporting things installed over directory
      symlinks: report all symlinks and their targets.
    - Reinstall base system packages missing upon removal with
      --no-install-recommends.
    - Mount /dev/pts into the chroot. Wanted by recent apt.
    - Fix usage of schroot with chroot names without ':'.  (Closes: #773874)
    - Resolve distro aliases before setting PIUPARTS_DISTRIBUTION.
    - Fix running debootstrap if --do-not-verify-signatures is given.
      (Closes: #781673)
  * piuparts.conf:
    - Enable --warn-on-debsums-errors for all jessie tests.
    - Add new suite: jessie-pu (test only packages in jessie-proposed-updates).
    - Add new suite: jessie-rcmd (test with --install-recommends).
    - Add new suite: wheezy2jessie-rcmd (test with --install-recommends).
    - Add new suite: stretch.
    - Add new suite: jessie2stretch.
  * piuparts.conf.anbe: Add many more example sections.
  * distros.conf: Reactivate 'testing' and 'stable' aliases.
  * piupartslib/packagesdb.py:
    - Consider logfile age in addition to the time waiting for recycling.
  * piuparts-slave.py:
    - Handle Ctrl-C while downloading Packages files and flush/unreserve, too.
    - Catch another exception that may happen while talking to the master.
  * detect_archive_issues: Move archive_issues.txt from htdocs/ to master/.
  * detect_piuparts_issues: Detect transient apt-cache failures.
  * generate_daily_report: Remove obsolete .html files (e.g. summaries for
    removed source packages or obsolete maintainer addresses) after 30 days.
  * reschedule_oldest_logs:
    - Fix gradual oldest-first recycling if nearly all logs are candidates.
    - Recycle/expire pass/ logs only if the section is (recycle-)idle.
  * scripts-apt-first/pre_distupgrade_zz_apt_first: New custom script for
    upgrading apt first and having the new apt perform the remaining upgrade.
  * scripts-sysvinit/pre_distupgrade_zz_sysvinit: New custom script for doing
    wheezy->jessie upgrade tests while keeping sysvinit as init if possible.
  * scripts/pre_remove_40_find_unowned_lib_links: Ignore /lib/ld-lsb.so.[123]
    links created by lsb-core.
  * scripts-no-usr-share-doc: Add exception for localepurge.
  * post_distupgrade_base_cleanup: New custom script for generalized libdbX.Y
    exceptions.
  * Update exceptions for squeeze-lts.
  * Add/update exceptions for many packages.
  * Add/update some bug templates.
  * known_problems/{initdscript_lsb_header_issue,insserv_error}.conf:
    Report "service.*already provided", too.

  [ Holger Levsen ]
  * piuparts.conf.pejacevic: add new suite: jessie2proposed.
  * piuparts.conf.piu-slave-1und1-01: merge changes from pejacevic config but
    replace amd64 with i386.
  * crontab-master.in: update webpages every six hours.
  * piuparts-reports.py:
    - Link to the new "Debian Package Tracker" (tracker.debian.org) instead to
      the old "Package Tracker System" (PTS).
    - Switch links to lintian.debian.org to https.
  * crontab-slave.in: try to start slave every hour to make sure it's always
    running.
  * Use "autopep8 --max-line-length=160" to re-format all .py files, then also
    use "-a" on a 2nd run.
  * test_config.py: update for Jessie being stable and Stretch being the new
    testing suite.
  * debian/copyright: Remove space from W3C FreeUse licence name, thanks
    lintian.
  * Update piuparts.py, piuparts.1.txt and README_server.txt due to the fact
    that jessie is the new stable and testing is stretch now.

 -- Holger Levsen <holger@debian.org>  Mon, 27 Apr 2015 16:46:29 +0200

=== debian/control ===
--- 
+++ 
@@ -1,5 +1,6 @@
 Source: piuparts
-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
+XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel

## piuparts 0.72

=== debian/changelog ===
piuparts (0.72) unstable; urgency=medium

  [ Holger Levsen ]
  * instances/piuparts.conf.pejacevic: test jessie2bpo and jessie2bpo2stretch.
  * piuparts.py:
    - Fix devpts mounting to use the correct gid=5,mode=620 mount options.
      Patch taken from Adam Conrad. (Closes: #829146)
    - explain (as a code comment) why /root/.rnd shouldn't be ignored.
      (Closes: #750099)
    - Add /var/log/apt/eipp.log.xz to ignored files. (Closes: #830527)
  * custom-scripts/scripts/pre_remove_exceptions: force removal of usrmerge
    package. (Closes: #798374)

  [ Stefano Rivera ]
  * Don't test the current Debian release status, tracking that is
    distro-info-data's problem. (Closes: #827411)

 -- Holger Levsen <holger@debian.org>  Wed, 03 Aug 2016 11:24:56 +0200

piuparts (0.71) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Define namedtuple FileInfo globally s.t. it can be pickled.
    - New option --no-check-valid-until to set apt option
      Acquire::Check-Valid-Until=false for testing archived releases.
    - Clear all locale settings from the environment before running commands
      in the chroot.
  * piuparts.conf:
    - Use --no-check-valid-until for squeeze.
    - New section [wheezy-security] (also used by wheezy LTS).
    - New section [jessie-security].
  * distros.conf: squeeze-* has been archived/removed.
  * piuparts-analyze.py:
    - Skip logfile on HTTPError while querying the BTS.
  * piuparts-reports.py:
    - Skip section on HTTPError while downloading Packages.
  * post_setup_forbid_home: Adjust for basefiles now shipping /home/
  * Add/adjust some exceptions.

  [ Holger Levsen ]
  * Bump standards version to 3.9.8, no changes needed.

 -- Holger Levsen <holger@debian.org>  Thu, 05 May 2016 14:03:30 +0200

piuparts (0.70) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/sysctl.d/99-sysctl.conf (dangling symlink to ../sysctl.conf)
      + /var/log/btmp
    - Canonicalize mountpoint inside the chroot to avoid mounting over
      symlinks and possibly outside the chroot.
    - --install-remove-install runs 'apt-get install --reinstall $pkg', too.
  * post_distupgrade_base_cleanup: Remove libprocps3 in stretch.
  * pre_remove_40_find_unowned_lib_links: Handle another mpi alternative.
  * Add bug template for maintainer scripts incorrectly complaining about
    being called with unknown arguments.

  [ Holger Levsen ]
  * conf/distros.conf and instances/piuparts.conf.pejacevic: move squeeze to
    archive.debian.org, stop testing squeeze only suites - but keep testing
    upgrades to wheezy suites.
  * Fix typo in piuparts_slave_join.8.txt, thanks lintian.

 -- Holger Levsen <holger@debian.org>  Tue, 08 Mar 2016 13:00:22 +0100

piuparts (0.69) unstable; urgency=medium

  * piuparts.py: add to ignored_files:
    - /var/lib/pkcs11proxyd/ (Closes: #810703)
  * piuparts.1.txt: Fix typos, thanks to Дилян Палаузов and lintian.
  * debian/control:
    - Bump standards version to 3.9.7, no changes needed.
    - Use more secure https URL for Vcs-Git: header, thanks lintian.
    - Use /git/ not /cgit/ in Vcs-* headers.
  * debian/copyright: bump years for my contributions to 2016.

 -- Holger Levsen <holger@debian.org>  Sat, 13 Feb 2016 12:46:10 +0100

piuparts (0.68) unstable; urgency=medium

  * Dedicated to the memory of Ian Murdock.
    Thank you very much for starting and shaping Debian, Ian! The world would
    be very different today without your work and you will never be forgotten.

  [ Andreas Beckmann ]
  * piuparts.py:
    - Simplify mounting/unmounting into the chroot.
    - Mount a 64 MB tmpfs onto /dev/shm in the chroot.  (Closes: #793487)

  [ Sven Haardiek ]
  * Add option "--single-packages" to test every package specified via path or
    package name individually. (Closes: #810237)

  [ Michael Prokop ]
  * piuparts.py:
    - Execute dist-upgrade also when using --existing-chroot option.
      (Closes: #798266)

 -- Holger Levsen <holger@debian.org>  Tue, 02 Feb 2016 10:33:40 +0100

piuparts (0.67) unstable; urgency=medium

  [ Holger Levsen ]
  * Add wheezy-pu to the suites being tested. (Closes: #800094)

  [ Andreas Beckmann ]
  * piuparts.py:
    - Ensure /etc/mtab exists in the chroot.
    - Record and compare file owner and group names instead of uid/gid.
  * Add support for adequate tag ldd-failure. (Closes: #793108)
  * scripts/post_distupgrade_exceptions:
    - Fix the /etc/nsswitch.conf wheezy -> jessie upgrade handling.
  * Update custom scripts handling databases.
  * Add bug template for wheezy -> jessie -> stretch upgrades.

 -- Holger Levsen <holger@debian.org>  Sat, 17 Oct 2015 16:32:06 +0200

piuparts (0.66) unstable; urgency=medium

  * Add python-lzma to build-depends, as the tests need it now.

 -- Holger Levsen <holger@debian.org>  Wed, 26 Aug 2015 00:59:42 +0200

piuparts (0.65) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Create sources.list entries for --testdebs-repo with '[ trusted=yes ]'
      to avoid needing --do-not-verify-signatures which would act globally.
    - Add --fake-essential-packages option to include packages in the base
      chroot that are not removed after the test. These are available during
      purge and for checking against mistreatment.
    - Increase permitted command output volume from 3 MB to 4 MB (for daptup).
    - Only ignore 'dpkg -i' failures that can be fixed by 'apt-get -f
      install'.  (Closes: #794628)
    - Set Architecture of piuparts-depends-dummy to match the package to be
      tested.
  * piuparts.conf.anbe: Add some more example sections.
  * piupartslib/packagesdb.py:
    - Put package in 'dependency-does-not-exist' state if a pass/ log exists
      but a dependency has been removed from the archive since then.
    - Prepare improvements for handling foreign arch dependencies.
  * piupartslib/open_packages_url(): Support xz-compressed and uncompressed
    Packages files.


## piuparts 0.73

=== debian/changelog ===
piuparts (0.73) unstable; urgency=medium

  * Add new option, --hard-link, and do *not* use it by default.
    (Closes: #841025)

 -- Holger Levsen <holger@debian.org>  Tue, 06 Dec 2016 18:14:19 +0100

## piuparts 0.73%7ebpo8%2b1

=== debian/changelog ===
piuparts (0.73~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Holger Levsen <holger@debian.org>  Sun, 18 Dec 2016 12:35:12 +0100

=== debian/control ===
--- 
+++ 
@@ -1,11 +1,10 @@
 Source: piuparts
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
+Maintainer: piuparts developers team <piuparts-devel@lists.alioth.debian.org>
 Uploaders:
  Holger Levsen <holger@debian.org>
 Section: devel
 Priority: extra
-Standards-Version: 3.9.6
+Standards-Version: 3.9.8
 Build-Depends:
  debhelper (>= 9.20120909~),
  python (>= 2.7),
@@ -15,14 +14,15 @@
  python-nose,
  python-debianbts,
  python-yaml,
- python-mox3
+ python-mox3,
+ python-lzma
 Build-Depends-Indep:
  asciidoc,
  git,
  xmlto
 Homepage: https://piuparts.debian.org
-Vcs-Git: git://anonscm.debian.org/piuparts/piuparts.git
-Vcs-Browser: https://anonscm.debian.org/cgit/piuparts/piuparts.git
+Vcs-Git: https://anonscm.debian.org/git/piuparts/piuparts.git
+Vcs-Browser: https://anonscm.debian.org/git/piuparts/piuparts.git
 X-Python-Version: >= 2.7
 
 Package: piuparts
@@ -84,7 +84,7 @@
  as it is done on https://piuparts.debian.org/.
  .
  This package provides the piuparts-master, which needs one or more slaves to
- operate. It also contains piuparts-reports to generate web pages with the
+ operate. It also contains piuparts-report to generate web pages with the
  testing results as well as documentation.
 
 Package: piuparts-slave
@@ -118,6 +118,7 @@
 Depends:
  python-apt,
  python-distro-info,
+ python-lzma,
  ${misc:Depends},
  ${python:Depends}
 Breaks:
@@ -125,7 +126,7 @@
 Replaces:
  piuparts (<= 0.44)
 Description: common piuparts components
- piupartslib, common library used by piuparts-master, -reports, -analyze and
+ piupartslib, common library used by piuparts-master, -report, -analyze and
  -slave.
  .
  See https://piuparts.debian.org or the piuparts package to learn more about

## piuparts 0.75

=== Makefile ===
--- 
+++ 
@@ -157,6 +157,11 @@
 
 
 # for maintainer convenience only
+check-whitespace:
+	grep -r --exclude-dir .git --exclude '*.pyc' --exclude '*.png' --exclude '*.ico' -E '\s+$$' . || echo "no trailing whitespace found"
+	grep -r --exclude-dir .git --exclude '*.pyc' --exclude '*.png' --exclude '*.ico' -P ' \t' . || echo "no space-tab combo found"
+
+# for maintainer convenience only
 tg-deps:
 	tg summary --graphviz | dot -T png -o deps.png
 	xli deps.png &

=== debian/changelog ===
piuparts (0.75) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/network/
      + /etc/php/7.0/ and selected subdirs
      + /var/lib/apache2/
    - Run panic handlers in reverse order.
    - Add --shell-on-error option to simplify debugging of piuparts failures.
      Starts an interactive shell in the chroot if an error occurred.
    - Unmount /proc/sys/fs/binfmt_misc only if mounted.
    - Query the apt version in the chroot.  (Closes: #851517)
    - Use apt_pkg.version_compare().
  * piuparts.conf:
    - Add new suite: stretch-rcmd (test with --install-recommends).
    - Add new suite: jessie2stretch-rcmd (test with --install-recommends).
    - Add new suite: stretch-security.
    - Add new suite: stretch-pu (test packages in stretch-proposed-updates).
    - Add new suite: stretch2proposed.
    - Reduce delay before rescheduling untestable packages.
  * piuparts-analyze.py:
    - Adjust debianbts syntax to be compatible with both jessie and stretch.
    - Improve exception handling.
  * Handle more database setup issues.
  * Add/adjust some exceptions for ancient packages.
  * scripts/pre_install_extras: Add examples how to preseed license acceptance
    for non-free and downloader packages.
  * scripts/pre_distupgrade_zz_database-server: Run pg_upgradecluster during
    dist-upgrades.
  * scripts/post_distupgrade_hack_debsums: Limit to squeeze->wheezy and merge
    into scripts/post_distupgrade_exceptions.
  * scripts/{pre,post}_remove_exceptions: Support removal of essential
    packages with apt-get from stretch onwards.
  * known_problems/piuparts-depends-dummy_error.conf: Recognize the failure
    from 'apt-get install piuparts-depends-dummy.deb'.
  * known_problems/problems_and_no_force_error.conf: Recognize the apt 1.1
    message on attempted removal of essential packages.
  * master-bin/detect_piuparts_issues: Recognize more cases of full disks.

 -- Holger Levsen <holger@debian.org>  Wed, 25 Jan 2017 13:19:30 +0100

piuparts (0.74) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /etc/modprobe.d/
    - Add new class of is_testable_* custom scripts: A non-zero return value
      makes the test succeed without actually installing the package. Use for
      packages that cannot be tested with piuparts by design or are broken in
      an unfixable way.  (Closes: #682739)
    - Ensure /etc/resolv.conf in the chroot has permissions 0644 to match a
      possible recreation of that file by resolvconf.  (Closes: #660350)
    - Increase output limit to 8 MB.  (Closes: #794331)
    - Increase single command time limit to 60 minutes.
  * piuparts.conf:
    - New section [sid-strict], testing with --install-remove-install and
      failing on leftover files.  (Closes: #604406)
    - Only warn on leftover files for [sid] and use the same settings for
      both [sid] and [stretch], since these are now used by britney to block
      testing migration in case of regressions.
  * piuparts.conf.anbe: Add some more example sections.
  * piuparts-slave.py:
    - Increase test timeout to 90 minutes.
  * piuparts-analyze.py:
    - Also consider bugs filed against source packages.
  * piuparts-reports.py:
    - Mark arch:all packages with an :all suffix in package lists.
    - Report skipped tests.
  * Makefile: Add check-whitespace target looking for trailing whitespace etc.
  * scripts/pre_install_database-server: Use default-mysql-* from stretch
    onwards.
  * scripts/post-{install,purge}-exceptions: Wait for dkms progress indicator
    to terminate.
  * scripts/post_distupgrade_exceptions: Work around some jessie->stretch
    issues.
  * scripts/is_testable_uninstallable: New custom script to exclude some
    uninstallable (or similarly broken) packages from being tested.
  * scripts/post_setup_minimize: New custom script to minimize chroots.
    - Remove tzdata and lsb-base from sid and stretch.
  * scripts/post_setup_dummy_users: New custom script to create dummy groups
    and users that block ids that are likely being used by the host system.
  * scripts/post_{setup,distupgrade}_experimental: Removed, obsolete since
    restoring the initial package selection supports downgrades (0.64).
  * custom-scripts/scripts-debug-{remove,purge}/: Improved debugging of
    maintainer scripts during package removal.
  * Overhaul some more custom scripts.
  * known_problems/debsums_mismatch_*.conf: Report missing symlinks and
    directories.
  * known_problems/needs_rebuild_issue.conf: Report "called
    emacs-package-install as a new-style add-on, but has no compat file"
  * known_problems/test_was_skipped_issue.conf: New known problem for skipped
    tests.
  * master-bin/detect_network_issues: Detect "E: The repository '.*' does no
    longer have a Release file."
  * master-bin/detect_piuparts_issues: Detect 'invoke-rc.d: initscript mysql,
    action "restart" failed.'
  * master-bin/reschedule_piuparts_tests: New experimental helper script for
    rescheduling piuparts tests based on detected known problems.

  [ Holger Levsen ]
  * Apply patch by Antonio Ospite to workaround #847788 by force-unmounting
    /proc/sys/fs/binfmt_misc - some java packages trigger update-binfmts,
    which mounts /proc/sys/fs/binfmt_misc but never unmounts it.
    (Closes: #704037) - Thanks Antonio!
  * Add build-depends to dh-python, thanks lintian.
  * Bump copyright years.

  [ Sean Whitton ]
  * piuparts.py: use `apt-get install ./foo.deb` instead of `dpkg -i
    ./foo.deb && apt-get install -yf` for more reliable dependency
    resolution. (Closes: #825487)

 -- Holger Levsen <holger@debian.org>  Sun, 15 Jan 2017 11:59:00 +0100

=== debian/control ===
--- 
+++ 
@@ -7,6 +7,7 @@
 Standards-Version: 3.9.8
 Build-Depends:
  debhelper (>= 9.20120909~),
+ dh-python,
  python (>= 2.7),
  python-debian,
  python-apt,

## piuparts 0.77~bpo8+1

=== debian/changelog ===
piuparts (0.77~bpo8+1) jessie-backports; urgency=medium

  * Rebuild for jessie-backports.

 -- Holger Levsen <holger@debian.org>  Thu, 22 Jun 2017 14:26:18 +0200

piuparts (0.77) unstable; urgency=medium

  [ Andreas Beckmann ]
  * distros.conf:
    - Add aliases for oldstable and oldoldstable.
    - Update aliases for stretch being released as stable.
  * piuparts.py:
    - Add to ignored_files:
      + /etc/rc.local
      + /etc/X11/Xwrapper.config  (Closes: #859929)
      + /var/lib/apt/daily_lock
  * piuparts-analyze.py:
    - Do not ignore Ctrl-C.
  * scripts/post_distupgrade_base_cleanup: Remove (transitional) sysvinit from
    stretch.  (Closes: #860819)
  * scripts/pre_distupgrade_zz_database-server: Do not migrate manually from
    mysql-server to default-mysql-server (aka mariadb-server), there is now a
    transitional mysql-server package in stretch.

  [ Holger Levsen ]
  * piuparts-report.py:
    - update navigation to point to piuparts.conf-template.pejacevic.

 -- Holger Levsen <holger@debian.org>  Sat, 03 Jun 2017 23:08:19 +0200

piuparts (0.76) unstable; urgency=medium

  [ Andreas Beckmann ]
  * piuparts.py:
    - Add to ignored_files:
      + /usr/share/texmf/ls-R
    - Remove from ignored_files:
      - /usr/share/keyrings/debian-archive-removed-keys.gpg~
    - Do not require --scriptsdir for proper operation.  (Closes: #855038)
    - Make install_over_symlink tests fail by default, add
      --warn-on-install-over-symlink option to demote this to a warning.
    - Add --install-suggests option.
    - Fall back to generating the reference chroot state on-the-fly if the
      --end-meta file is missing.
    - Make logged command lines shell-safe with pipes.quote().
  * piuparts.conf:
    - Use --warn-on-install-over-symlink for tests ending before stretch.
    - Enable scripts-log-alternatives for [sid] and [stretch].  (See: #850917)
    - Add new suite: wheezy222testing, upgrading wheezy -> jessie -> stretch.
  * piuparts.conf.anbe: Add some more example sections.
  * distros.conf: Add support for sid-debug, stretch-debug.
  * piuparts-slave.py:
    - Replace literal ESC (0x1b) chars with string '[ESC]' for easier
      copy+paste from logfiles.
    - Make logged command lines shell-safe with pipes.quote().
  * piuparts-analyze.py:
    - Also process untestable/*.log.
  * instances/*: Generate the config files piuparts.conf.pejacevic,
    piuparts.conf.piu-slave-bm-a, piuparts.conf.piu-slave-ubc-01 (new) and
    piuparts.conf.piu-slave-1und1-01 (unused) from a common template to keep
    the settings in sync, since they should only differ in mirror and arch.
  * Clean up leftover /etc/piuparts/scripts/post_setup_experimental.
    (Closes: #854317)
  * scripts/post_setup_minimize:
    - Exclude gcc-4.8-base from jessie chroot.
  * scripts/pre_install_database-server: Add/fix some database requirements.
  * scripts/pre_distupgrade_zz_database-server: Switch from mysql-server to
    default-mysql-server (aka mariadb-server) for selected packages on
    upgrades to stretch, otherwise they will lose their database server.
    Try 'dpkg --configure --pending' after failed upgrades in case the
    database server was started too late - after a client tried to access it.
  * scripts/pre_remove_40_find_missing_md5sums: Correctly escape backslashes
    in filenames.
  * scripts/pre_remove_exceptions: Handle removal of more packages pulling in
    'init'.
  * Add/update exceptions for ancient packages in
    scripts/is_testable_uninstallable, scripts/pre_install_exceptions, and
    scripts/post_distupgrade_exceptions.
  * master-bin/detect_piuparts_issues: Recognize more cases of full disks.
  * master-bin/detect_network_issues: Recognize unauthenticated packages.
  * Add known_problems/problems_and_no_force_issue.conf to recognize non-fatal
    failures when attempting to remove essential packages.
  * Add bug template for failing to upgrade from testing to sid.
  * Add bug template for shipping broken symlinks.

  [ Holger Levsen ]
  * piuparts.py:
    - Apply patch from Maxime Lareo to allow usage of --keep-sources-list
      without --basetgz. (Closes: #841157)
    - Add to ignored_patterns:
      + /srv/.* (Closes: #848186)
    - Add my copyright note according to git blame.
  * Add python (>= 2.7) to the depends of piuparts-master and piuparts-slave
    as dh-python has been changed to only add python depends if it finds
    python code in PATH. Thanks lintian.
  * Replace httpredir.debian.org with deb.debian.org everywhere: with deb.d.o
    apt will use SRV records to go directly to the mirror, with httpredir.d.o
    there will be http redirects for every file.
  * slave_run: Fix bug which prevented a different number of slaves to be
    started than defined in the configuration. Also add a check to ensure that
    this optional argument is an integer and within the defined maximum number
    of slaves.
  * slave_stop: New script to stop all piuparts-slaves on a host.
  * slave_stop.8: Add new manpage for this new script, also update slave_run.8
    to mention slave_stop.8.
  * Update README_pejacevic.txt and README_server.txt.
  * Drop instances/piuparts.conf.lamarr and …/piuparts.conf.goldwasser.
  * htdocs/index.tpl:
    - Announce 2nd piuparts-slave, explain this is a three host setup now,
      mention that pejacevic is a four core system and other news.
    - Make "contribute" a link.
  * archive_old_logs: use xargs -P $NUM_CPU and -n 1 to compress old logs in
    parallel.
  * update-piuparts-(master|slave)-setup: touch $PIUPARTS_TMPDIR/.nobackup to
    exclude it from backups made by DSA.
  * conf/crontab-master.in: run piuparts-report twice a day instead of trying
    four times a day, which hasn't worked out for a long time.
  * generate_daily_report.in: measure runtime of this script and the scripts
    started by it.
  * detect_(network|piuparts|archive)_issues.in: measure runtimes too.
  * reschedule_oldest_logs.in: measure runtime.



## piuparts 0.77

=== Makefile ===
--- 
+++ 
@@ -23,7 +23,7 @@
 SCRIPTS_TEMPLATES	 = $(wildcard *.in master-bin/*.in slave-bin/*.in conf/*.in)
 SCRIPTS_PYTHON_BINARY	 = $(wildcard *.py master-bin/*.py slave-bin/*.py)
 SCRIPTS_GENERATED	 = $(SCRIPTS_TEMPLATES:.in=) $(SCRIPTS_PYTHON_BINARY:.py=)
-DOCS_GENERATED		 = piuparts.1 piuparts.1.html piuparts_slave_run.8 piuparts_slave_join.8 README.html README_server.html
+DOCS_GENERATED		 = piuparts.1 piuparts.1.html piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 README.html README_server.html
 
 define placeholder_substitution
 	sed -r \
@@ -49,6 +49,7 @@
 build: build-stamp
 
 build-stamp: $(SCRIPTS_GENERATED) $(DOCS_GENERATED) Makefile
+	$(MAKE) -C instances
 	$(MAKE) python-syntax-check
 	touch $@
 
@@ -69,6 +70,9 @@
 piuparts_slave_join.8: piuparts_slave_join.8.txt
 	a2x -f manpage piuparts_slave_join.8.txt
 
+piuparts_slave_stop.8: piuparts_slave_stop.8.txt
+	a2x -f manpage piuparts_slave_stop.8.txt
+
 piuparts.1.html: piuparts.1.txt
 	a2x --copy -f xhtml piuparts.1.txt
 
@@ -78,10 +82,11 @@
 	install -d $(DESTDIR)$(man1dir)
 	install -m 0644 piuparts.1 $(DESTDIR)$(man1dir)/
 	install -d $(DESTDIR)$(man8dir)
-	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 $(DESTDIR)$(man8dir)/
+	install -m 0644 piuparts_slave_run.8 piuparts_slave_join.8 piuparts_slave_stop.8 $(DESTDIR)$(man8dir)/
 	gzip -9f $(DESTDIR)$(man1dir)/piuparts.1
 	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_run.8
 	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_join.8
+	gzip -9f $(DESTDIR)$(man8dir)/piuparts_slave_stop.8
 	install -m 0644 piuparts.1.html $(DESTDIR)$(docdir)/
 
 install-conf: build-stamp
@@ -154,6 +159,7 @@
 	rm -f piuparts.1.xml README.xml README_server.xml docbook-xsl.css piuparts.html
 	rm -f *.pyc piupartslib/*.pyc master-bin/*.pyc slave-bin/*.pyc tests/*.pyc
 	rm -f $(SCRIPTS_GENERATED)
+	$(MAKE) -C instances clean
 
 
 # for maintainer convenience only

=== debian/control ===
--- 
+++ 
@@ -65,6 +65,7 @@
  xz-utils,
  python-yaml,
  ${misc:Depends},
+ python (>= 2.7),
  ${python:Depends}
 Recommends:
  apache2 | httpd,
@@ -98,6 +99,7 @@
  screen,
  sudo,
  ${misc:Depends},
+ python (>= 2.7),
  ${python:Depends}
 Suggests:
  schroot
